"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
exports.Consumer = ({ children, manager }) => {
    let key = undefined;
    const checkManager = () => {
        if (!manager) {
            throw new Error('No portal manager defined');
        }
    };
    const handleInit = () => __awaiter(void 0, void 0, void 0, function* () {
        checkManager();
        yield Promise.resolve();
        key = manager === null || manager === void 0 ? void 0 : manager.mount(children);
    });
    React.useEffect(() => {
        if (key) {
            checkManager();
            manager === null || manager === void 0 ? void 0 : manager.update(key, children);
        }
    }, [children, manager]);
    React.useEffect(() => {
        handleInit();
        return () => {
            if (key) {
                checkManager();
                manager === null || manager === void 0 ? void 0 : manager.unmount(key);
            }
        };
    }, []);
    return null;
};
